"use strict";
/*
 * Copyright (C) 2018 Shuma Yoshioka
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("../interfaces");
var ExpressHandler = /** @class */ (function () {
    function ExpressHandler(req, res) {
        this.req = req;
        this.res = res;
    }
    ExpressHandler.prototype.get = function (key) {
        if (this.req.cookies.hasOwnProperty(key)) {
            return this.req.cookies[key];
        }
        else {
            return undefined;
        }
    };
    ExpressHandler.prototype.set = function (key, value, options) {
        var filled = __assign({}, interfaces_1.UniversalCookies.Options.DEFAULT, options);
        this.res.cookie(key, value, {
            expires: filled.expires,
            path: filled.path,
            domain: filled.domain,
            secure: filled.secure,
        });
    };
    ExpressHandler.prototype.remove = function (key, options) {
        var filled = __assign({}, interfaces_1.UniversalCookies.Options.DEFAULT, options);
        this.res.clearCookie(key, {
            expires: filled.expires,
            path: filled.path,
            domain: filled.domain,
            secure: filled.secure,
        });
    };
    return ExpressHandler;
}());
exports.ExpressHandler = ExpressHandler;
